# Evidence Profiles for Validity Threats in Program Comprehension Experiments

This repository contains data and scripts used in and generated in our research to care for reproducibility, repeatability, and transparency.

## Validity Threats in Program Comprehension
The `/threat-review` folder contains all files that relate to our review of threats to validity in program comprehension experiments.
- [coding-summary.xlsx](threat-review/coding-summary.xlsx) contains the list of primary papers, extracted text passages with threats to validity and corresponding codes, and the final lists of threat codes, threat categories and threat themes.

## Evidence Profiles
The `/evidence-profiles` folder contains all files that relate to the evidence profiles generated in our work.
- [threat-1-programming-experience.xlsx](evidence-profiles/threat-1-programming-experience.xlsx), [threat-2-program-length.xlsx](evidence-profiles/threat-2-program-length.xlsx), and [threat-3-comprehension-measures.xlsx](threat-3-comprehension-measures.xlsx) contain the artifacts generated by the systematic literature search for each of the three threats. Specifically, it includes the list of included and excluded literature for each search source and the final list of papers to be evaluated as evidence.
- [evidence-profiles.xlsx](evidence-profiles/evidence-profiles.xlsx) contains the evidence profiles for the three most frequently cited threats to validity. For each profile, we include the list of evidence and corresponding DOIs, descriptions for the evidence types used when scoring, the individual scores by each reviewer and the final score after reaching agreement.

## Source Code
The `/code` folder contains the source code used in the analysis in this work.
- [a-threat-review.R](code/a-threat-review.R) and [b-evidence-profiles.R](code/b-evidence-profiles.R) are the R scripts with the source code for the review of threats to validity and the evidence profiles. These scripts are mainly concerned with counting and composing the different levels of threat codes and generating the plots for both parts of the methodology.
- The `.xlsx` files in the `/code/input` and `/code/output` folders contain the input data used by and output data generated from the two R scripts.
- The `/code/output/plots` folder contains the plots used in the paper, generated by the two R scripts.